//========================================================================================
// TI Calculator File Support Framework
//
// TI API Support - To be included in "main" application support modules
// that use the TI File Support libraries.
// �2001-2003 by Texas Instruments Incorporated
// All Rights Reserved.
//
// Software Design: Stephen L. Reid (MGTS)
// Initial Design : 05 March 2001
// OS X Framework : 02 Sept 2002
//
//========================================================================================
//


#ifndef __TI_FILE_API__
#define __TI_FILE_API__

IOReturn	TIFileSupport( TIFileSelector selector, TIFileOperationsParmBlock **inPB, CFStringRef *str );
OSErr 		FURLCoerceDescToFURL(const AEDesc *fromDesc, DescType toType, long handlerRefcon, AEDesc *toDesc);

//========================================================================================
// API Access to TI File Support Package
//========================================================================================
#define TI_WriteFile( pb )                      TIFileSupport( TIFS_WRITE_FILE, pb, NULL )
#define TI_ReadFile( pb )                       TIFileSupport( TIFS_READ_FILE, pb, NULL )
#define TI_IdentifyFile( pb )                   TIFileSupport( TIFS_IDENTIFY_FILE, pb, NULL )
#define TI_ReleaseDescriptors( pb )             TIFileSupport( TIFS_RELEASE_DESCRIPTORS, pb, NULL )
#define TI_AllocateNewFileParameterBlock( pb )	TIFileSupport( TIFS_GET_NEW_PARAMETERBLOCK, pb, NULL )
#define TI_DestroyFileParameterBlock( pb )		TIFileSupport( TIFS_DESTROY_PARAMETERBLOCK, pb, NULL )
#define TI_InitializeFileParameterBlock( pb )	TIFileSupport( TIFS_INITIALIZE_PB, pb, NULL )
#define TI_DetermineFileExtension( pb, str )	TIFileSupport( TIFS_DETERMINE_EXTENSION, pb, str )

#endif

