//
//  TIDocument.h
//  TIAppKit
//
//  Created by otusweb on Fri Feb 27 2004.
//  Copyright (c) 2004 Texas Instruments Inc.. All rights reserved.
//

#import <AppKit/AppKit.h>
#import "TISendPanel.h"
#import "NSDocument+FileType.h"
#import <TIConnectManagerXInteraction/DeviceFolder.h>
#import <TIConnectManagerXInteraction/TISendOperation.h>

@class fileLocatorReplacement;

@interface TIDocument : DocumentWithFileType  {
    IBOutlet NSWindow				*loadingPlugin;
    IBOutlet NSProgressIndicator	*spinner;
    IBOutlet NSTextField			*dialogText;

    NSString						*deviceName;
	fileLocatorReplacement			*deviceFileLocator;
    TIReplaceResult					replaceDialogResult;
    NSLock							*replaceDialogLock;
	BOOL							isSaving;
}

/*"Actions"*/
- (IBAction)sendToDevice:(id)sender;
- (IBAction)sendToAll:(id)sender;
//- (BOOL)readFromFile:(NSString *)fileName ofType:(NSString *)docType;

/*"Accessors"*/
- (NSString *)deviceName;
- (void)setDeviceName:(NSString *)newDeviceName;
- (fileLocatorReplacement *)deviceFileLocator;
- (void)setDeviceFileLocator:(fileLocatorReplacement *)newDeviceFileLocator;
- (BOOL)isSaving;
- (void)setIsSaving:(BOOL)inFlag;
	
	/*"Utilities"*/
- (void)sendToDeviceWithPath:(NSString *)path;
- (void)sendToFolder:(TIDeviceFolder *)inDestination;
- (BOOL)prepareSendPanel:(TISendPanel *)inPanel;

@end
