//
//  TINavPanel.h
//  TIAppKit
//
//  Created by otusweb on Fri Feb 20 2004.
//  Copyright (c) 2004 Texas Instruments Inc.. All rights reserved.
//
//Feb 2010: Changes Made by a0869729 (Srinath Madas) as part of Issue id 83322 for deprecated symbols on 10.6
//Mar 2010: Changes Made by a0869729 to resolve issue 87005 - Icons do not appear in Device Explorer

#import <AppKit/AppKit.h>
#import <TIConnectManagerXInteraction/Computer.h>
#import <TIConnectManagerXInteraction/DeviceFolder.h>


@interface TINavPanel : NSPanel
{
    IBOutlet NSButton *okButton;
    IBOutlet NSButton *helpButton;
    IBOutlet NSBrowser *deviceBrowser;
    IBOutlet NSView *panelContentView;
	IBOutlet NSProgressIndicator *spinner;
    TIComputer* computerToDescribe;
	NSInteger modalResult;
}

	/*"Actions"*/
- (IBAction)cancel:(id)sender;
- (IBAction)ok:(id)sender;
- (IBAction)changeSelection:(NSBrowser *)sender;
- (IBAction) refreshDevices: (id) sender;

    /*"Initializer"*/
- (id) initWithComputer: (TIComputer*) inComputer;

	/*"Accessors"*/
- (TIComputer*) computerToDescribe;
- (void) setComputerToDescribe:(TIComputer*)newComputerToDescribe;
- (TIDeviceObject*) selectedItem;

- (void)beginSheetForDirectory:(TIDeviceFolder*)inFolder modalForWindow:(NSWindow *)docWindow modalDelegate:(id)modalDelegate didEndSelector:(SEL)didEndSelector contextInfo:(void *)contextInfo;
- (NSInteger)runModalForDirectory:(TIDeviceFolder*)inFolder withDelegate: (id) delegate;
@end

@interface TINavPanel (private)
- (NSButton*) okButton;
- (NSBrowser *) deviceBrowser;
- (void) setDeviceBrowser:(NSBrowser *)newDeviceBrowser;
@end

@interface NSObject (TINavPanelDelegate)
- (void)TISendPanel:(id) panel selectionDidChange:(TIDeviceObject *)selectedObject;
@end

@interface NSObject (TINavPanelCompletionRoutine) 
-(void)TINavPanelDidEnd:(TINavPanel *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo;
@end
