//
//  TIToolLocator.h
//  Device Explorer
//
//  Created by otusweb on Wed Nov 19 2003.
//  Copyright (c) 2003 Texas Instruments Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
/*"Notification"*/
extern NSString* TIToolFoundNotification;
extern NSString* TIAllToolsFoundNotification;

/*"tool information key"*/
extern NSString* TIToolNameKey;
extern NSString* TIToolPathKey;
extern NSString* TIToolIconPathKey;
extern NSString* TIToolDescriptionKey;
extern NSString* TIToolTasksKey;
extern NSString* TIBundleSignatureKey;
extern NSString* TIToolTaskName;
extern NSString* TIToolTaskCategory;
extern NSString* TIToolCreateCategory;
extern NSString* TIToolViewCategory;
extern NSString* TIToolOtherCategory;
 
@interface TIToolLocator : NSObject 
{
    NSArray *tools;
    BOOL alreadySearchedTools;
	BOOL bundleProvideTITools;
}

+ (TIToolLocator*) sharedToolLocator;

/*"action"*/
- (void) searchForTools;
- (void)launchTool:(NSString*) inToolName;
- (void)launchTask:(NSInteger)taskIndex ofTool: (NSString*) inToolName;

/*"Accessors"*/
- (NSArray *) tools;
- (NSArray *) toolsFromDisk;
- (void) setTools:(NSArray *)newTools;
- (BOOL) alreadySearchedTools;
- (void) setAlreadySearchedTools:(BOOL)newAlreadySearchedTools;

@end
