//
//  DeviceFile.h
//  Device Explorer
//
//  Created by otusweb on Tue May 14 2002.
//  Copyright (c) 2002 Texas Instruments Incorporated. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "DeviceObject.h"

/*"flag for files"*/
extern NSString *flagLocked;
extern NSString *flagArchived;
extern NSString *flagNone;


@interface TIDeviceFile : TIDeviceObject <NSCopying>
{
    NSString *fileExtension;	/*"return the extension that the file would have if it was saved to the hard drive"*/
    SInt32 index;               /*"Index of the file in the directory structure to be able to uniquely reference it"*/
}

/*"initialiser"*/
- (id) initWithContainer: (TIDeviceFolder*) inContainer
                    name: (NSString*) inName
                    size: (NSNumber*) inSize
            internalName: (NSString*) inInternalName
    nonHumanReadableKind: (NSString*) inkind
                   flags: (NSArray*) inFlag
               extension: (NSString*) inExtension
                   index: (SInt32) inIndex;

/*"Accessors"*/
- (NSString *) fileExtension;
- (SInt32) index;

/*"Utilities"*/
- (OSStatus) saveIn: (NSString*) pathToSaveIn;
@end