//
//  NSArray+CustomPerformSelector.h
//  Device Explorer
//
//  Created by otusweb on Wed Jun 26 2002.
//  Copyright (c) 2002 Texas Instruments Inc.. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface NSArray (makeObjectsOfClassPerformSelector)
- (void)makeObjectsOfClass:(Class)inClass performSelector:(SEL)inSelector;
- (void)makeObjectsOfClass:(Class)inClass performSelector:(SEL)inSelector withObject:(id)inObject;
- (id)subArrayWithClass:(Class)inClass;
- (void)makeObjectsMemberOfClass:(Class)inClass performSelector:(SEL)inSelector;
- (void)makeObjectsMemberOfClass:(Class)inClass performSelector:(SEL)inSelector withObject:(id)inObject;
- (id)subArrayWithMemberOfClass:(Class)inClass;
- (void)makeObjectsOfKindOfClass:(Class)inClass performSelector:(SEL)inSelector;
- (void)makeObjectsOfKindOfClass:(Class)inClass performSelector:(SEL)inSelector withObject:(id)inObject;
- (id)subArrayOfKindOfClass:(Class)inClass;
- (id)arrayWithResultOfSelector:(SEL)inSelector;
- (NSArray *)arrayWithNoDuplicate;
- (BOOL)containsObject:(id)anObject withComparisonSelector:(SEL)inSelector;
- (NSInteger)indexOfObject:(id)anObject withComparisonSelector:(SEL)inSelector;
@end

@interface NSMutableArray (makeObjectsOfClassPerformSelector)
- (void)removeAllObjectsOfClass:(Class)inClass;
- (void)removeDuplicateObject;
@end