//
//  TIReceiveOperation.h
//  Device Explorer
//
//  Created by otusweb on Tue May 06 2003.
//  Copyright (c) 2003 Texas Instruments Incorporated. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "TIComOperation.h"

extern NSString *deleteAfterSave;

@interface TIReceiveOperation : TIComOperation
{
    NSArray* itemToSave;
    NSArray* fileURLsToSaveIn;
    NSInteger totalByteNeededToBeSent;
    NSInteger totalByteSent;
    NSInteger totalByteSentInPreviousThread;
}

/*"initializer"*/
- (id) initWithItems: (NSArray*) deviceItems
     destinationURLs: (NSArray*) inFileURLsToSaveIn
sendingCompletionCallTo: (id) target
          withOption: (NSString*)inOption;
+ (id) receiveOperationWithItems: (NSArray*) deviceItems
                 destinationURLs: (NSArray*) inFileURLsToSaveIn
         sendingCompletionCallTo: (id) target
                      withOption: (NSString*)inOption;

/*"Accessors"*/
- (NSArray*) itemToSave;
- (NSArray*) fileURLsToSaveIn;
- (NSInteger) totalByteNeededToBeSent;
- (NSInteger) totalByteSent;


@end
